#include "stack.h"
#include <stdlib.h>

struct _stack {
    COPYFUN _copy;
    struct _stackElem *_top;
};

struct _stackElem {
    ELEMENT _elem;
    struct _stackElem *_next;
};

void newStack(Stack *s, COPYFUN cp) {
    *s = (Stack) calloc(1, sizeof(struct _stack));
    if (*s != NULL) {
	(*s)->_copy = cp;
	(*s)->_top = NULL;
    }
}

void deleteStack(Stack *s) {
    if (isEmpty(*s)) {
	free(*s);
	*s = NULL;
    }
}

BOOL isEmpty(Stack s) {
    return s->_top == NULL;
}

ELEMENT pop(Stack s) {
    ELEMENT elem = NULL;
    if (!isEmpty(s)) {
	struct _stackElem *st_elem = s->_top;
	elem = st_elem->_elem;
	s->_top = st_elem->_next;
	free(st_elem);
    }
    return elem;
}

void push(Stack s, ELEMENT elem) {
    struct _stackElem *st_elem;
    st_elem = (struct _stackElem*) calloc(1, sizeof(struct _stackElem));
    if (st_elem != NULL) {
	st_elem->_elem = s->_copy(elem);
	st_elem->_next = s->_top;
	s->_top = st_elem;
    }
}
