#include <stdio.h>
#include <dlfcn.h>	/* wg. dlopen(), ... */

int main() {
    void *handle;
    double (*sin)(double); /* Zeiger fuer die Funktion sin() */
    double x = 3.1415;

	/* dyn. Bibliothek (shared object) oeffnen */
    if (!(handle = dlopen("libm.so", RTLD_LAZY))) {
	fprintf(stderr, "%s\n", dlerror());
	return 1;
    }
    
	/* Zeiger auf Funktion in dyn. Bibliothek (shared object) beschaffen */
    if (!(sin = dlsym(handle, "sin"))) {
	fprintf(stderr, "%s\n", dlerror());
	return 1;
    }
    
    printf("sin(%f) = %f\n", x, (*sin)(x));

	/* dyn. Bibliothek (shared object) wieder schliessen */
    dlclose(handle);
    
    return 0;
}
