#include "stack.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLEN 80

int main() {
    char line[MAXLEN];
    Stack s;
    
	/*
	 * char *strdup(char *)
	 * dupliziert den uebergebenen String
	 * und liefert einen Zeiger auf die Kopie.
	 */
    newStack(&s, (COPYFUN) strdup);
    if (s == NULL) {
	fprintf(stderr, "not enough memory\n");
	return 1;
    }

	/*
	 * Zwei unmittelbar aufeinanderfolgende,
	 * die hoechstens durch Whitespace voneinander
	 * getrennt sind, werden zu einer String-Konstanten!
	 */
    puts("String-Stack\n"
	 "------------\n"
	 "Moegliche Kommandos:\n"
	 " +elem  push\n"
	 " -      pop\n"
	 " ?      isEmpty\n"
	 " EOF    ENDE\n");

    while (printf("> "), fgets(line, MAXLEN, stdin)) {
	int len = strlen(line);
	if (line[len-1] == '\n')	/* '\n' am Zeilenende entfernen */
	    line[len-1] = '\0';
	switch (line[0]) {
	    case '+':
		push(s, line+1);
		printf("push: elem = \"%s\"\n", line+1); /* oder &line[1] */
		break;
	    case '-': {
		ELEMENT elem = pop(s);
		if (elem != NULL)
		    printf("pop: elem = \"%s\"\n", (char*) elem);
		else
		    puts("pop failed");
		break;
		}
	    case '?':
		puts(isEmpty(s) ? "stack is empty" : "stack is _not_ empty");
		break;
	    default:
		puts("expected [+-?] as first character (or EOF)");
		break;
	}
    }

    puts("");

    while (!isEmpty(s))
	printf("pop: elem = \"%s\"\n", (char*) pop(s));

    deleteStack(&s);

    return 0;
}
